
	// Provides convenience fns for retrieving and saving.
	// No data is cached here. Consumers must store the data themselves, or rely on the AjaxQueue cache.

	var Tabs = {

		_call: function(url, data, done) {
			done = done || $.noop;
			var dfd = $.Deferred();

			$.ajaxQueue({ 
				url      : url,
				json     : data,
				priority : 'very-high',
				success  : function(result) {
					done(result);
					dfd.resolve();
				}, 
				logErrors: url, //TODO: give a sensible message
				error    : function(result) {
					console.warn('Tabs.' + url + ': ', result);
					if(result.error) for(var i in result.error) console.log(result.error[i]);
					//done(result);
					//dfd.resolve();
				}
			});
			return dfd.promise();
		},

		load: function (ready) {
			Tabs._call(ECMWF.options.ajax.backend.get_dashboard_set, {name: null}, ready);
		},

		add_dashboard: function(set_name, done) {
			console.log('Tabs.add_dashboard');
			Tabs._call(ECMWF.options.ajax.backend.add_dashboard, {set: set_name}, done);
		},

		remove_dashboard: function(name, done) {
			console.log('Tabs.remove_dashboard: ' + name);
			Tabs._call(ECMWF.options.ajax.backend.remove_dashboard, {name: name}, done);
		},

		get_dashboard: function(name, done) {
			Tabs._call(ECMWF.options.ajax.backend.get_dashboard, {name: name}, done);
		},

		save_dashboard: function(data, done) {
			console.log('save_dashboard: ' + data.title);
			Tabs._call(ECMWF.options.ajax.backend.save_dashboard, data, done);
		},

		save_dashboard_set: function(data, done) {
			console.log('Tabs.save_dashboard_set');
			Tabs._call(ECMWF.options.ajax.backend.save_dashboard_set, data, done);
		},


		Widget: {
			add: function(dashboard, widget, done) {
				console.log('Tabs.add_widget', widget);
				widget.dashboard = dashboard;
				Tabs._call(ECMWF.options.ajax.backend.add_widget, widget, done);
			},

			remove: function(name, done) {
				console.log("Tabs.remove_widget: " + name);
				Tabs._call(ECMWF.options.ajax.backend.remove_widget, {name: name}, done);
			},

			move: function(widget_name, src, dest, done) {
				console.log("Tabs.move_widget: " + widget_name, '. ', src + ' --> ' + dest);
				if(src !== dest){
					Tabs._call(ECMWF.options.ajax.backend.move_widget, {widget: widget_name, src: src, dest: dest}, function(result){
						var widgets = Array.prototype.concat.apply([], result.dashboards.src.columns);
						if(!~$.inArray(widget_name, Array.prototype.concat.apply([], result.dashboards.src.columns))){
							done(result);
						}else{
							console.warn('widget not removed');
						}
					});
				}else{
					console.warn('ignoring request to move to same dashboard.');
				}
			},

			save: function(data, done) {
				console.log("Tabs.Widget.save: " + data.name);
				Tabs._call(ECMWF.options.ajax.backend.save_widget, data, done);
			},

			get: function(name, done) {
				//console.log('Tabs.get_widget: ' + name);
				return Tabs._call(ECMWF.options.ajax.backend.get_widget, {name: name}, done);
			}
		}
	};


