define(['jquery', 'toolbar', './tool', 'tool-button'], function($, Toolbar) {

	var name = 'redo';

	function Tool(toolbar) {

		function enable(_, msg) {
			if(msg.redo) {
				toolbar.enable(name);
			} else {
				toolbar.disable(name);
			}
		}

		$.getMessageBus().listen('undo-list-changed', enable);

		this.destroy = function () {
			$.getMessageBus().forget('undo-list-changed', enable);
		}

		this.name = function () {
			return name;
		};

		this.tool_tip = function() {
			return 'Redo';
		};

		this.click = function(event, message_bus ) {
			$.redoLast();
		};

		this.disabled = true;
	};

	Toolbar.register(name, function(toolbar) { return new Tool(toolbar) });
});
