define(['jquery', 'filterable-list', 'virtual-dom/h', './input_filter', './scrollbar', './index.css'], function($, list, h, InputFilter, Scrollbar){

	var VGrid = function(options){
		var self = this;

		this.options = $.extend({
			view_mode: 'groups',
			element: $() // temporary
		}, options);

		this.widgets = {
			input_filter: new InputFilter({on_filter: function(text) {
				list.lookup_filter_by_name('text').enable().on_change(null, text);
			}}),
			scrollbar: new Scrollbar()
		}

		switch(this.options.view_mode){
			case 'groups':
				this.view = require('./views/groups')
		}
		this.view = new this.view({
			on_needs_render: function() {
				list.have_filtering.then(function() {
					$('#product-select').trigger('render');
				});
			}
		})
		list.have_filtering.then(function() {
			self.resize();
			self.options.element.trigger('render');
		});

		list.subscribe(self, self._on_filter = function() {
			self.view.groups_valid = false;
			self.view._positions_valid = false;
			self.options.element.trigger('render');
		})
	}

	VGrid.prototype = {
		render: function() {
			var w = this.widgets
			w.scrollbar.state.inner_height = 20 // TODO

			return h('.catalogue-grid', {style: {height: '430px'}}, [
				h('.head', [w.input_filter.render()]),
				h('.outer', [
					h('.scrollable.ps-container.ps-active-y', {style: {height: '100%'}}, [
						this.view.render(),
						w.scrollbar.render()
					])
				]),
				h('.foot', [list.filtered.length + ' matching items']),
			])
		},

		resize: function() {
			this.view.resize();
			//delete this._pending.sizing;
			//this._update();
			//self.container.scroll();
		},
	}

	return VGrid;
})
